Vue Popup - Show and Hide the Popup

API

NOTE
In this article, the Button UI component is used to demonstrate how to show and hide the Popup. This choice is made for purely demonstrational purposes, and you can do the same operations using another UI component following the same guidelines.

To show or hide the Popup programmatically, bind the visible property of Popup to a component property. After that, change the latter property, and the Popup will appear or disappear.

  • <template>
  • <div>
  • <DxPopup
  • title="Popup Title"
  • v-model:visible="isPopupVisible">
  • <template>
  • <p>Popup content</p>
  • </template>
  • </DxPopup>
  • <DxButton
  • text="Show the Popup"
  • @click="showPopup"
  • />
  • <DxButton
  • text="Hide the Popup"
  • @click="hidePopup"
  • />
  • </div>
  • </template>
  •  
  • <script>
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DxPopup } from 'devextreme-vue/popup';
  • import { DxButton } from 'devextreme-vue/button';
  •  
  • export default {
  • components: {
  • DxPopup,
  • DxButton
  • },
  • data() {
  • return {
  • isPopupVisible: false
  • }
  • },
  • methods: {
  • showPopup() {
  • this.isPopupVisible = true;
  • },
  • hidePopup() {
  • this.isPopupVisible = false;
  • }
  • }
  • }
  •  
  • </script>

User Interaction

The Popup can also be hidden when a user clicks outside it. To control this behavior of the Popup, use the hideOnOutsideClick property.

  • <template>
  • <DxPopup
  • v-model:visible="isPopupVisible"
  • :hide-on-outside-click="true"
  • title="Popup Title"
  • />
  • </template>
  •  
  • <script>
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DxPopup } from 'devextreme-vue/popup';
  •  
  • export default {
  • components: {
  • DxPopup
  • },
  • data() {
  • return {
  • isPopupVisible: true
  • };
  • }
  • }
  • </script>

Events

To execute certain commands before or after the Popup was shown/hidden, handle the showing, shown, hiding or hidden event. If the event handling function is not going to be changed during the lifetime of the UI component, assign it to the corresponding onEventName property when you configure the UI component.

  • <template>
  • <DxPopup ...
  • @showing="onShowing"
  • @shown="onShown"
  • @hiding="onHiding"
  • @hidden="onHidden"
  • />
  • </template>
  •  
  • <script>
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { DxPopup } from 'devextreme-vue/popup';
  •  
  • export default {
  • components: {
  • DxPopup
  • },
  • methods: {
  • onShowing(e) {
  • // Handler of the 'showing' event
  • },
  • onShown(e) {
  • // Handler of the 'shown' event
  • },
  • onHiding(e) {
  • // Handler of the 'hiding' event
  • },
  • onHidden(e) {
  • // Handler of the 'hidden' event
  • }
  • }
  • }
  • </script>
See Also

Angular Popup - Show and Hide the Popup

API

NOTE
In this article, the Button UI component is used to demonstrate how to show and hide the Popup. This choice is made for purely demonstrational purposes, and you can do the same operations using another UI component following the same guidelines.

To show or hide the Popup programmatically, bind the visible property of Popup to a component property. After that, change the latter property, and the Popup will appear or disappear.

HTML
TypeScript
  • <dx-popup
  • title="Popup Title"
  • [(visible)]="isPopupVisible">
  • <div *dxTemplate="let data of 'content'">
  • <p>Popup content</p>
  • </div>
  • </dx-popup>
  • <dx-button
  • text="Show the Popup"
  • (onClick)="isPopupVisible = true">
  • </dx-button>
  • <dx-button
  • text="Hide the Popup"
  • (onClick)="isPopupVisible = false">
  • </dx-button>
  • import { DxPopupModule } from "devextreme-angular";
  • // ...
  • export class AppComponent {
  • isPopupVisible: boolean = false;
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxPopupModule
  • ],
  • // ...
  • })

Using DxPopupService

DevExtreme Popup includes a DxPopupService that allows you to initiate popups directly from .ts files without template code. The use of services that display popups is a common practice in Angular libraries.

DxPopupService is imported from 'devextreme-angular/ui/popup' and functions as a typical Angular service. To show a Popup with DxPopupService, call the open method. The method takes two arguments:

  1. The Angular component class to be used as the content of the popup.
  2. The popup configuration, which includes properties of the Popup component.

The open method returns a DxPopupServiceComponent object. This type extends DxPopupComponent with a contentRef property. Use contentRef.instance to access the component that serves as popup content.

app.component.ts
employee-info.component.ts
  • import { DxPopupService } from 'devextreme-angular/ui/popup';
  • // ...
  • export class AppComponent {
  • employees: Employee[];
  •  
  • constructor(
  • employeeService: EmployeeService,
  • private popupService: DxPopupService
  • ) {
  • this.employees = employeeService.getEmployees();
  • }
  •  
  • showInfo(employee: Employee) {
  • const popupRef = this.popupService.open(EmployeeInfoComponent, {
  • showTitle: true,
  • title: 'Information',
  • container: 'html',
  • width: 300,
  • showCloseButton: true,
  • });
  •  
  • popupRef.contentRef.instance.currentEmployee = employee;
  • }
  • }
  • import { Component, Input } from '@angular/core';
  • @Component({
  • standalone: true,
  • selector: '',
  • template: `<div>
  • <p>
  • Full Name:
  • <span>
  • {{ currentEmployee['FirstName'] }}
  • {{ currentEmployee['LastName'] }}
  • </span>
  • </p>
  • <p>
  • Birth Date:
  • <span>{{ currentEmployee['BirthDate'] }}</span>
  • </p>
  • <p>
  • Address:
  • <span>{{ currentEmployee['Address'] }}</span>
  • </p>
  • <p>
  • Hire Date:
  • <span>{{ currentEmployee['HireDate'] }}</span>
  • </p>
  • <p>
  • Position:
  • <span>{{ currentEmployee['Position'] }}</span>
  • </p>
  • </div>`,
  • })
  •  
  • export class EmployeeInfoComponent {
  • @Input() currentEmployee: Record<string, any> = {};
  • }

You can access the Popup instance through DxPopupServiceComponent. Call the hide() method to close the Popup programmatically:

app.component.ts
  • import { DxPopupService, DxPopupServiceComponent } from 'devextreme-angular/ui/popup';
  • // ...
  • export class AppComponent {
  • employees: Employee[];
  • popupRef!: DxPopupServiceComponent;
  •  
  • constructor(
  • employeeService: EmployeeService,
  • private popupService: DxPopupService
  • ) {
  • this.employees = employeeService.getEmployees();
  • }
  •  
  • showInfo(employee: Employee) {
  • this.popupRef = this.popupService.open(EmployeeInfoComponent, {
  • showTitle: true,
  • title: 'Information',
  • container: 'html',
  • width: 300
  • });
  •  
  • this.popupRef.contentRef.instance.currentEmployee = employee;
  • }
  •  
  • closePopup() {
  • this.popupRef.instance.hide();
  • }
  • }

User Interaction

Enable the showCloseButton property to allow a user to hide the Popup component by clicking the Close button.

HTML
  • <dx-popup
  • [showTitle]="true"
  • [showCloseButton]="true">
  • </dx-popup>

The Popup can also be hidden when a user clicks outside of it. To control this Popup behavior, use the hideOnOutsideClick property.

HTML
TypeScript
  • <dx-popup
  • title="Popup Title"
  • [(visible)]="isPopupVisible"
  • [hideOnOutsideClick]="true">
  • </dx-popup>
  • import { DxPopupModule } from "devextreme-angular";
  • // ...
  • export class AppComponent {
  • isPopupVisible: boolean = true;
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxPopupModule
  • ],
  • // ...
  • })

You can also implement a custom Close button inside the Popup. Refer to the following demo for more information:

View Demo

Events

To execute certain commands before or after the Popup was shown/hidden, handle the showing, shown, hiding or hidden event. If the event handling function is not going to be changed during the lifetime of the UI component, assign it to the corresponding onEventName property when you configure the UI component.

HTML
TypeScript
  • <dx-popup ...
  • (onShowing)="popup_showing($event)"
  • (onShown)="popup_shown($event)"
  • (onHiding)="popup_hiding($event)"
  • (onHidden)="popup_hidden($event)">
  • </dx-popup>
  • import { DxPopupModule } from "devextreme-angular";
  • // ...
  • export class AppComponent {
  • popup_showing (e) {
  • // Handler of the "showing" event
  • }
  • popup_shown (e) {
  • // Handler of the "shown" event
  • }
  • popup_hiding (e) {
  • // Handler of the "hiding" event
  • }
  • popup_hidden (e) {
  • // Handler of the "hidden" event
  • }
  • }
  • @NgModule({
  • imports: [
  • // ...
  • DxPopupModule
  • ],
  • // ...
  • })
See Also

React Popup - Show and Hide the Popup

API

NOTE
In this article, the Button UI component is used to demonstrate how to show and hide the Popup. This choice is made for purely demonstrational purposes, and you can do the same operations using another UI component following the same guidelines.
jQuery

To show or hide the Popup programmatically, call the show() or hide() method. The same thing can be done using the toggle(showing) method. Pass true or false to this method to show or hide the Popup, respectively.

JavaScript
$(function() {
    $("#popupContainer").dxPopup({
        title: "Popup Title",
        contentTemplate: function () {
            return $("<p />").text("Popup content");
        }
    });
    $("#showButton").dxButton({
        text: "Show the Popup", 
        onClick: function () {
            $("#popupContainer").dxPopup("show");
            // === or ===
            $("#popupContainer").dxPopup("toggle", true);
        } 
    });
    $("#hideButton").dxButton({
        text: "Hide the Popup", 
        onClick: function () {
            $("#popupContainer").dxPopup("hide");
            // === or ===
            $("#popupContainer").dxPopup("toggle", false);
        } 
    });
});
ASP.NET MVC Controls

To show or hide the Popup programmatically, call the show() or hide() method. The same thing can be done using the toggle(showing) method. Pass true or false to this method to show or hide the Popup, respectively.

Razor C#
Razor VB
@(Html.DevExtreme().Popup()
    .ID("popup")
    .Title("Popup Title")
    .ContentTemplate(@<text>
        <p>Popup content</p>
    </text>)
)

@(Html.DevExtreme().Button()
    .ID("showButton")
    .Text("Show the Popup")
    .OnClick(@<text>
        function () {
            $("#popup").dxPopup("show");
            // === or ===
            $("#popup").dxPopup("toggle", true);
        } 
    </text>)
)

@(Html.DevExtreme().Button()
    .ID("hideButton")
    .Text("Hide the Popup")
    .OnClick(@<text>
        function () {
            $("#popup").dxPopup("hide");
            // === or ===
            $("#popup").dxPopup("toggle", false);
        } 
    </text>)
)
@Code
    Html.DevExtreme().Popup() _
        .ID("popup") _
        .Title("Popup Title") _
        .ContentTemplate(Sub()
            @<text>
                <p>Popup content</p>
            </text>
        End Sub).Render()
    Html.DevExtreme().Button() _
        .ID("showButton") _
        .Text("Show the Popup") _
        .OnClick("showButton_click").Render()
    Html.DevExtreme().Button() _
        .ID("hideButton") _
        .Text("Hide the Popup") _
        .OnClick("hideButton_click").Render()
End Code

<script>
    function showButton_click() {
        $("#popup").dxPopup("show");
        // === or ===
        $("#popup").dxPopup("toggle", true);
    }
    function hideButton_click() {
        $("#popup").dxPopup("hide");
        // === or ===
        $("#popup").dxPopup("toggle", false);
    }
</script>
Angular

To show or hide the Popup programmatically, bind the visible property of Popup to a component property. After that, change the latter property, and the Popup will appear or disappear.

HTML
TypeScript
<dx-popup
    title="Popup Title"
    [(visible)]="isPopupVisible">
    <div *dxTemplate="let data of 'content'">
        <p>Popup content</p>
    </div>
</dx-popup>
<dx-button
    text="Show the Popup"
    (onClick)="isPopupVisible = true">
</dx-button>
<dx-button
    text="Hide the Popup"
    (onClick)="isPopupVisible = false">
</dx-button>
import { DxPopupModule } from "devextreme-angular";
// ...
export class AppComponent {
    isPopupVisible: boolean = false;
}
@NgModule({
    imports: [
        // ...
        DxPopupModule
    ],
    // ...
})
Vue

To show or hide the Popup programmatically, bind the visible property of Popup to a component property. After that, change the latter property, and the Popup will appear or disappear.

Code
<template>
    <div>
        <DxPopup
            title="Popup Title"
            v-model:visible="isPopupVisible">
            <template #content>
                <p>Popup content</p>
            </template>
        </DxPopup>
        <DxButton
            text="Show the Popup"
            @click="showPopup"
        />
        <DxButton
            text="Hide the Popup"
            @click="hidePopup"
        />
    </div>
</template>

<script>
import 'devextreme/dist/css/dx.light.css';

import { DxPopup } from 'devextreme-vue/popup';
import { DxButton } from 'devextreme-vue/button';

export default {
    components: {
        DxPopup,
        DxButton
    },
    data() {
        return {
            isPopupVisible: false
        }
    },
    methods: {
        showPopup() {
            this.isPopupVisible = true;
        },
        hidePopup() {
            this.isPopupVisible = false;
        }
    }
}

</script>
React

To show or hide the Popup programmatically, bind the visible property of Popup to a state property. After that, change the latter property, and the Popup will appear or disappear.

Code
import React from 'react';
import 'devextreme/dist/css/dx.light.css';

import { Popup } from 'devextreme-react/popup';
import { Button } from 'devextreme-react/button';

const renderContent = () => {
    return (
        <p>Popup content</p>
    );
};

class App extends React.Component {
    constructor(props) {
        super(props);

        this.state = {
            isPopupVisible: false
        };

        this.showPopup = this.showPopup.bind(this);
        this.hidePopup = this.hidePopup.bind(this);
    }

    showPopup() {
        this.setState({
            isPopupVisible: true
        });
    }

    hidePopup() {
        this.setState({
            isPopupVisible: false
        });
    }

    render() {
        return (
            <div>
                <Popup
                    title="Popup Title"
                    visible={this.state.isPopupVisible}
                    contentRender={renderContent}
                    onHiding={this.hidePopup}
                />
                <Button
                    text="Show the Popup"
                    onClick={this.showPopup}
                />
                <Button
                    text="Hide the Popup"
                    onClick={this.hidePopup}
                />
            </div>
        );
    }
}

export default App;

User Interaction

Enable the showCloseButton property to allow a user to hide the Popup component by clicking the Close button.

jQuery
JavaScript
$(function() {
    $("#popupContainer").dxPopup({
        showTitle: true,
        showCloseButton: true
    });
});
Angular
HTML
<dx-popup
    [showTitle]="true"
    [showCloseButton]="true">
</dx-popup>
Vue
Code
<template>
    <DxPopup
        :show-title="true"
        :show-close-button:"true"
    />
</template>

<script>
import 'devextreme/dist/css/dx.light.css';

import { DxPopup } from 'devextreme-vue/popup';

export default {
    components: {
        DxPopup
    }
}
</script>
React
Code
import React from 'react';
import 'devextreme/dist/css/dx.light.css';

import { Popup } from 'devextreme-react/popup';

class App extends React.Component {
    return (
        <Popup
            showTitle={true}
            showCloseButton={true}
        />
    );
}

export default App;

The Popup can also be hidden when a user clicks outside of it. To control this Popup behavior, use the hideOnOutsideClick property.

jQuery
JavaScript
$(function() {
    $("#popupContainer").dxPopup({
        title: "Popup Title",
        visible: true,
        hideOnOutsideClick: true
    });
});
Angular
HTML
TypeScript
<dx-popup
    title="Popup Title"
    [(visible)]="isPopupVisible"
    [hideOnOutsideClick]="true">
</dx-popup>
import { DxPopupModule } from "devextreme-angular";
// ...
export class AppComponent {
    isPopupVisible: boolean = true;
}
@NgModule({
    imports: [
        // ...
        DxPopupModule
    ],
    // ...
})
Vue
Code
<template>
    <DxPopup
        v-model:visible="isPopupVisible"
        :hide-on-outside-click="true"
        title="Popup Title"
    />
</template>

<script>
import 'devextreme/dist/css/dx.light.css';

import { DxPopup } from 'devextreme-vue/popup';

export default {
    components: {
        DxPopup
    },
    data() {
        return {
            isPopupVisible: true
        };
    }
}
</script>
React
Code
import React from 'react';
import 'devextreme/dist/css/dx.light.css';

import { Popup } from 'devextreme-react/popup';

class App extends React.Component {
    constructor(props) {
        super(props);

        this.state = {
            isPopupVisible: true
        };

        this.onHiding = this.onHiding.bind(this);
    }

    onHiding() {
        this.setState({
            isPopupVisible: false
        });
    }

    render() {
        return (
            <Popup
                visible={this.state.isPopupVisible}
                hideOnOutsideClick={true}
                title="Popup Title"
            />
        );
    }
}

export default App;

You can also implement a custom Close button inside the Popup. Refer to the following demo for more information:

View Demo

Events

To execute certain commands before or after the Popup was shown/hidden, handle the showing, shown, hiding or hidden event. If the event handling function is not going to be changed during the lifetime of the UI component, assign it to the corresponding onEventName property when you configure the UI component.

jQuery
JavaScript
$(function () {
    $("#popupContainer").dxPopup({
        // ...
        onShowing: function (e) {
            // Handler of the "showing" event
        },
        onShown: function (e) {
            // Handler of the "shown" event
        },
        onHiding: function (e) {
            // Handler of the "hiding" event
        },
        onHidden: function (e) {
            // Handler of the "hidden" event
        }
    });
});
Angular
HTML
TypeScript
<dx-popup ...
    (onShowing)="popup_showing($event)"
    (onShown)="popup_shown($event)"
    (onHiding)="popup_hiding($event)"
    (onHidden)="popup_hidden($event)">
</dx-popup>
import { DxPopupModule } from "devextreme-angular";
// ...
export class AppComponent {
    popup_showing (e) {
        // Handler of the "showing" event
    }
    popup_shown (e) {
        // Handler of the "shown" event
    }
    popup_hiding (e) {
        // Handler of the "hiding" event
    }
    popup_hidden (e) {
        // Handler of the "hidden" event
    }
}
@NgModule({
    imports: [
        // ...
        DxPopupModule
    ],
    // ...
})
Vue
Code
<template>
    <DxPopup ...
        @showing="onShowing"
        @shown="onShown"
        @hiding="onHiding"
        @hidden="onHidden"
    />
</template>

<script>
import 'devextreme/dist/css/dx.light.css';

import { DxPopup } from 'devextreme-vue/popup';

export default {
    components: {
        DxPopup
    },
    methods: {
        onShowing(e) {
            // Handler of the 'showing' event
        },
        onShown(e) {
            // Handler of the 'shown' event
        },
        onHiding(e) {
            // Handler of the 'hiding' event
        },
        onHidden(e) {
            // Handler of the 'hidden' event
        }
    }
}
</script>
React
Code
import React from 'react';
import 'devextreme/dist/css/dx.light.css';

import { Popup } from 'devextreme-react/popup';

class App extends React.Component {
    onShowing(e) {
        // Handler of the 'showing' event
    }

    onShown(e) {
        // Handler of the 'shown' event
    }

    onHiding(e) {
        // Handler of the 'hiding' event
    }

    onHidden(e) {
        // Handler of the 'hidden' event
    }

    render() {
        return (
            <Popup ...
                onShowing={this.onShowing}
                onShown={this.onShown}
                onHiding={this.onHiding}
                onHidden={this.onHidden}
            />
        );
    }
}

export default App;
jQuery

If you are going to change event handlers at runtime, or if you need to attach several handlers to a single event, subscribe to the events using the on(eventName, eventHandler) method.

JavaScript
const hiddenEventHandler1 = function (e) {
    // First handler of the "hidden" event
};

const hiddenEventHandler2 = function (e) {
    // Second handler of the "hidden" event
};

$("#popupContainer").dxPopup("instance")
    .on("hidden", hiddenEventHandler1)
    .on("hidden", hiddenEventHandler2);
See Also